// Simple parentheses balancer function

#include <string>
#include "book.h"
#include "lstack.h"

using std::cin;


bool isBalanced(const string &expression)
{
    const char LEFT = '(';
    const char RIGHT = ')';

    LStack<char> StackObj;

    int i;
    char next;
    char discard;
    bool failed = false;

    for(i = 0; !failed && (i < expression.size()); i++)
    {
        next = expression[i];
        if(next == LEFT)
        {
            StackObj.push(next);
        }
        else if((next == RIGHT) && (StackObj.length() > 0))
        {
            discard = StackObj.pop();
        }
        else if((next == RIGHT) && (StackObj.length() == 0))
        {
            failed = true;
        }
    }
    return (StackObj.length() == 0) && !failed;
}


int main()
{
    cout << "Enter a series of parentheses: ";
    string input;
    cin >> input;

    cout << endl;

    if(isBalanced(input))
    {
        cout << "Your parentheses are balanced." << endl;
    }
    else
    {
        cout << "Your parentheses are not balanced." << endl;
    }

    return 0;
}

